%------------------------------------------------
% Solve the ODE BV problem  f'' = 0
% with boundary conditions: f(xLeft)  = fLeft  = 0
%                           f(xRight) = fRight = 3
% using iterative finite difference approach.
%------------------------------------------------

clear all
close all
clc

x = linspace(0, 1, 21);            % make array of x values
N = length(x);

% f = 3 * ones(1, length(x));      % initialize f values
% f = 3 * rand(1, length(x));      % initialize f values

f(1) = 0;                          % set boundary values
f(N) = 3;

nFrames = 300;                     % number of frames in 'movie'

for ii = 1 : nFrames               % generate lots of plots

    for jj = 2 : (N-1)
        f(jj) = ( f(jj-1) + f(jj+1) ) / 2;
    end

    plot (x,f), xlabel('X axis'),...   % generate one plot
                ylabel('F axis'),...
                title('The plot title'),...
	            axis([0 1 0 3])
            
    % hold on                         % don't erase curves
    % pause(0.2)
    
    drawnow                           % force a rendering

end
beep