%------------------------------------------------
% Solve the ODE BV problem  f'' = x^2
% with boundary conditions: f(xLeft)  = fLeft  = 0.5
%                           f(xRight) = fRight = 1.5
% using iterative finite difference approach.
%------------------------------------------------

clear all
close all
clc

x = linspace(0, 2, 21);       % make array of x values
deltaX = x(2) - x(1);         % calculate deltaX
N = length(x);

% f = zeros(1, N);            % initialize f values (not needed)

f(1) = 0.5;                   % set boundary values
f(N) = 1.5;

nFrames = 500;                % number of frames in 'movie'

for ii = 1 : nFrames          % generate lots of plots

    for jj = 2 : (N-1)
        f(jj) = ( f(jj-1) + f(jj+1) - deltaX^2 * x(jj)^2 ) / 2 ;
    end

    % f(N) = f(N-1) - 0.5*deltaX^2 * x(N)^2;   % **Imitation Insulated BC**
    
    plot (x,f), xlabel('X axis'),...   % generate one plot
                ylabel('F axis'),...
                title('The Plot Title'),...
	            axis([0 2 0 2.0])
            
    % hold on                          % don't erase curves
    % pause(0.1)

    drawnow                            % force a rendering

end
beep                                   % hey, I'm done
